module Kount
  ##
  # This class extends the Request class and is used in the
  # process of sending updates to an existing transaction
  # generated by a previous Inquiry request.
  class Update < Request
    # Initialize an Update object
    #
    # Example usage
    #    {:MACK => "Y", :AUTH => "A"}
    #
    # @param initial_params [Hash] Initial params for request
    def initialize(initial_params = {})
      super(initial_params)
      # Default to mode U unless mode X is explicitly set
      add_params(MODE: 'U') unless initial_params[:MODE] == 'X'
    end

    # @param version [String] RIS version
    # @param merchant_id [String] Merchant ID
    # @param response_format [String] Response format (JSON)
    # @param ksalt [String] Kount supplied secret salt for KHASH
    def prepare_params(version, merchant_id, response_format, ksalt)
      super(version, merchant_id, response_format, ksalt)
      params
    end
  end
end
